[PATCH] perf test: Skip syscall enum test if no landlock syscall

Namhyung Kim posted 1 patch 6 hours ago
tools/perf/tests/shell/trace_btf_enum.sh | 6 +++++-
1 file changed, 5 insertions(+), 1 deletion(-)
[PATCH] perf test: Skip syscall enum test if no landlock syscall
Posted by Namhyung Kim 6 hours ago
The perf trace enum augmentation test specifically targets landlock_
add_rule syscall but IIUC it's an optional and can be opt-out by a
kernel config.

Currently trace_landlock() runs `perf test -w landlock` before the
actual testing to check the availability but it's not enough since the
workload always returns 0.  Instead it could check if perf trace output
has 'landlock' string.

Fixes: d66763fed30f0bd8c ("perf test trace_btf_enum: Add regression test for the BTF augmentation of enums in 'perf trace'")
Cc: Howard Chu <howardchu95@gmail.com>
Signed-off-by: Namhyung Kim <namhyung@kernel.org>
---
 tools/perf/tests/shell/trace_btf_enum.sh | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

diff --git a/tools/perf/tests/shell/trace_btf_enum.sh b/tools/perf/tests/shell/trace_btf_enum.sh
index 5a3b8a5a9b5cf296..e57ad6913f3e9316 100755
--- a/tools/perf/tests/shell/trace_btf_enum.sh
+++ b/tools/perf/tests/shell/trace_btf_enum.sh
@@ -27,7 +27,11 @@ trace_landlock() {
   echo "Tracing syscall ${syscall}"
 
   # test flight just to see if landlock_add_rule and libbpf are available
-  $TESTPROG
+  if ! perf trace $TESTPROG 2>&1 | grep -q landlock
+  then
+    echo "No landlock system call found. Fallback to non-syscall tracing."
+    return
+  fi
 
   if perf trace -e $syscall $TESTPROG 2>&1 | \
      grep -q -E ".*landlock_add_rule\(ruleset_fd: 11, rule_type: (LANDLOCK_RULE_PATH_BENEATH|LANDLOCK_RULE_NET_PORT), rule_attr: 0x[a-f0-9]+, flags: 45\) = -1.*"
-- 
2.48.0.rc2.279.g1de40edade-goog
Re: [PATCH] perf test: Skip syscall enum test if no landlock syscall
Posted by Howard Chu 6 hours ago
Hello Namhyung,

On Tue, Jan 21, 2025 at 4:17 PM Namhyung Kim <namhyung@kernel.org> wrote:
>
> The perf trace enum augmentation test specifically targets landlock_
> add_rule syscall but IIUC it's an optional and can be opt-out by a
> kernel config.
>
> Currently trace_landlock() runs `perf test -w landlock` before the
> actual testing to check the availability but it's not enough since the
> workload always returns 0.  Instead it could check if perf trace output
> has 'landlock' string.

I remember doing the landlock syscall nr ifdef checking and returning
-1... Somehow it's not there... Sorry.

>
> Fixes: d66763fed30f0bd8c ("perf test trace_btf_enum: Add regression test for the BTF augmentation of enums in 'perf trace'")
> Cc: Howard Chu <howardchu95@gmail.com>
> Signed-off-by: Namhyung Kim <namhyung@kernel.org>
> ---
>  tools/perf/tests/shell/trace_btf_enum.sh | 6 +++++-
>  1 file changed, 5 insertions(+), 1 deletion(-)
>
> diff --git a/tools/perf/tests/shell/trace_btf_enum.sh b/tools/perf/tests/shell/trace_btf_enum.sh
> index 5a3b8a5a9b5cf296..e57ad6913f3e9316 100755
> --- a/tools/perf/tests/shell/trace_btf_enum.sh
> +++ b/tools/perf/tests/shell/trace_btf_enum.sh
> @@ -27,7 +27,11 @@ trace_landlock() {
>    echo "Tracing syscall ${syscall}"
>
>    # test flight just to see if landlock_add_rule and libbpf are available

Wonder why I put 'libbpf' here, can you please change this comment to
'# test flight just to see if landlock_add_rule is available'
If you find this change appropriate?

> -  $TESTPROG
> +  if ! perf trace $TESTPROG 2>&1 | grep -q landlock
> +  then
> +    echo "No landlock system call found. Fallback to non-syscall tracing."

I wouldn't say it's a fallback, because the non-syscall test gets run
even if the landlock_add_rule syscall can be invoked. Why not say: 'No
landlock system call found, skipping to non-syscall tracing'?

> +    return
> +  fi
>
>    if perf trace -e $syscall $TESTPROG 2>&1 | \
>       grep -q -E ".*landlock_add_rule\(ruleset_fd: 11, rule_type: (LANDLOCK_RULE_PATH_BENEATH|LANDLOCK_RULE_NET_PORT), rule_attr: 0x[a-f0-9]+, flags: 45\) = -1.*"
> --
> 2.48.0.rc2.279.g1de40edade-goog
>

Other things LGTM.

Reviewed-by: Howard Chu <howardchu95@gmail.com>

Thanks,
Howard